clear;
addpath('D:\research\jplv7\distrib') % download the Matlab package provided by James LeSage from http://www.spatial-econometrics.com/ 
load  D:\research\2014_health_study\data\data_inhome\dad_edu\data_dad_edu;
format short;
tic;
ssd = 20160902;
rng(ssd);


G=118;       %  The number of groups %
raw_norm=0;  %  Choose 1 for row-normalized case; otherwise choose 0 %
T=250000;    %  Length of MCMC %
NN_1=0;
NN_2=0;
gsize=[];
outdegree=[];


for g=1:G;
    s=['w(' int2str(g) ').a=network' int2str(g)]; eval([s, ';']);
    s=['Y(' int2str(g) ').a=group' int2str(g) '(:,1)']; eval([s, ';']);
    s=['X(' int2str(g) ').a=group' int2str(g) '(:,2:12)']; eval([s, ';']);
    s=['clear group_' int2str(g)]; eval([s, ';']);      % remove raw data to save memory %
    s=['clear network_' int2str(g)]; eval([s, ';']);    % remove raw data to save memory %
    N=length(w(g).a);
    out=mean(sum(w(g).a,2));
    gsize=[gsize; N];
    outdegree=[outdegree; out];
    if raw_norm==1;
        rowsum_w=sum(w(g).a,2);
        for i=1:N;
            if rowsum_w(i)==0;
                rowsum_w(i)=1;
            end;
            w(g).a(i,:)=w(g).a(i,:)/rowsum_w(i);
        end;
    end;
end;

c_1=1; c_2=0.1; c_3=0.1; c_4=1;
acc_1=0; acc_2=0; acc_3=0; acc_4=zeros(G,1);

% assign parameter in prior distributions %
beta_0=zeros([1,11]);
B_0=eye(11)*100;
ALPHA_0=400.0;
sig0=1;
rho_0=2.2;
eta_0=0.1;

acc_rate1=zeros(T,1);
acc_rate2=zeros(T,1);
acc_rate3=zeros(T,1);
acc_rate4=zeros(G,T);

lambda_T =zeros([1,T]);   % save for lambda
beta_T   =zeros([11,T]);  % save for beta
alpha_T  =zeros([G,T]);   % save for alpha
sige_T   =zeros([1,T]);   % save for Sigma_e^2
 

% starting value of draw
sige_T(1)=0.14;


for t=2:T;
    tic;
    
    accept=0;
    if t<=500;
        lambda_1=randn(1)*0.005+lambda_T(t-1);
    else
        lambda_1=mvnrnd(lambda_T(t-1)',cov(lambda_T(1:t-1)')*2.38^2)*0.95+...
            mvnrnd(lambda_T(t-1)',eye(1)*0.1^2)*0.05;
    end;
    
    pp_l=0;
    
    for g=1:G;
        N=length(w(g).a);
        V=sige_T(t-1)*eye(N);
        S_1=eye(N)-lambda_1*w(g).a;
        S_2=eye(N)-lambda_T(t-1)*w(g).a;
        %ep_1=S_1*Y(g).a-[X(g).a ]*beta_T(:,t-1)-alpha_T(g,t-1);
        %p_2=S_2*Y(g).a-[X(g).a ]*beta_T(:,t-1)-alpha_T(g,t-1);
        ep_1=S_1*Y(g).a-[X(g).a w(g).a*X(g).a]*beta_T(:,t-1)-alpha_T(g,t-1);
        ep_2=S_2*Y(g).a-[X(g).a w(g).a*X(g).a]*beta_T(:,t-1)-alpha_T(g,t-1);
        like_1=log(det(S_1))-(1/2)*(ep_1)'/V*(ep_1);
        like_2=log(det(S_2))-(1/2)*(ep_2)'/V*(ep_2);
        pp_l=pp_l+like_1-like_2;
    end;
    if log(rand(1))<=pp_l;
        lambda_T(:,t)=lambda_1;
        acc_2=acc_2+1;
    else
        lambda_T(:,t)=lambda_T(:,t-1);
    end;
    acc_rate2(t,1)=acc_2/t;
    
    
    % THE SAMPLING OF BETA FROM PROSTERIOR DISTRIBUTION %
    ZVY=0;
    ZVX=0;
    for g=1:G;
        N=length(w(g).a);
        V=sige_T(t-1)*eye(N);
        SS=eye(N)-lambda_T(t)*w(g).a;
        YY=SS*Y(g).a-alpha_T(g,t-1);
        %ZZ=[X(g).a ];
        ZZ=[X(g).a w(g).a*X(g).a];
        ZVX=ZVX+ZZ'/V*ZZ;
        ZVY=ZVY+ZZ'/V*YY;
    end;
    beta_T(:,t)=norm_rnd(inv(inv(B_0)+ZVX))+((inv(B_0)+ZVX)\((B_0)\beta_0'+ZVY));
    
    
    % THE SAMPLING OF SIGMA_E^2 FROM PROSTERIOR DISTRIBUTION %
    ep_v=zeros(sum(gsize),1);
    count=0;
    for g=1:G;
        N=length(w(g).a);
        SS=eye(N)-lambda_T(t)*w(g).a;
        %ep=SS*Y(g).a-[X(g).a ]*beta_T(:,t)-alpha_T(g,t-1);
        ep=SS*Y(g).a-[X(g).a w(g).a*X(g).a]*beta_T(:,t)-alpha_T(g,t-1);
        ep_v(count+1:count+N)=ep;
        count=count+N;
    end;
    rho_1=rho_0+length(ep_v);
    sige_T(t)=(ep_v'*ep_v+eta_0)/chis_rnd(1,rho_1);
    
    % THE SAMPLING OF ALPHA_G FROM PROSTERIOR DISTRIBUTION %
    
    for g=1:G;
        N=length(w(g).a);
        dd=(ALPHA_0^(-1)+(sige_T(t))^(-1)*ones([1,N])/(eye(N))*ones([N,1]))^(-1);
        SS=eye(N)-lambda_T(t)*w(g).a;
        YY=SS*Y(g).a;
        XX=[X(g).a ];
        %XX=[X(g).a w(g).a*X(g).a];
        alpha_T(g,t)=sige_T(t)^(-1)*dd*ones([1,N])/(eye(N))*(YY-XX*beta_T(:,t))+randn(1)*sqrt(dd);
    end;
    
    
    if (t/100)-round(t/100)==0
        disp(t);
        toc;
        disp(lambda_T(t));
        disp(beta_T(:,t)');
        disp(sige_T(t));
        disp(acc_rate2(t,1));
    end;
    
end;
%save D:\research\2014_health_study\result\result_inhome_dadedu\result_inhome_dadedu lambda_T beta_T beta_T sige_T;

burn=50000;
lambda=[];
beta=[];
lambda=[lambda [mean(lambda_T(burn:T)); std(lambda_T(burn:T))] ];
temp=zeros(size(beta_T,1)*2,1);
for i=1:size(beta_T,1);
    temp(1+(i-1)*2)=mean(beta_T(i,burn:T),2);
    temp(2+(i-1)*2)=std(beta_T(i,burn:T),1,2);
end;
beta=[beta temp];
disp('endogenous effect');
disp(lambda);
disp('own');
disp(beta(1:size(beta_T,1),:));
disp('contextual');
disp(beta(size(beta_T,1)+1:size(beta_T,1)*2,:));
disp('variance');
disp(mean(sige_T(burn:T)));

