clear 
mata: mata clear
set more off
#delimit;
global dirdata  "D:\research\AddHealth"; 

cd $dirdata;
#delimit;
use sfriend,clear;
sort sqid;
save sfriend_sort,replace;

use Inschool.dta,clear;
keep sqid aid s2 s4 s6a s6b s6c s6d s6e s62b s62e s62o s62h s62k s62m s62n s62o s62p s59a;
sort sqid;
merge m:m sqid using sfriend_sort;
tab _merge;
drop _merge;
sort aid;

foreach friends in mf1aid mf2aid mf3aid mf4aid mf5aid ff1aid ff2aid ff3aid ff4aid ff5aid {;
replace `friends'=. if `friends'==77777777 | `friends'==88888888 | `friends'==99959995 | `friends'==99999999;
};

rename mf1aid fid1;
rename mf2aid fid2;
rename mf3aid fid3;
rename mf4aid fid4;
rename mf5aid fid5;
rename ff1aid fid6;
rename ff2aid fid7;
rename ff3aid fid8;
rename ff4aid fid9;
rename ff5aid fid10;
save sfriend_sort,replace;


use allwave1_inhome,clear;
sort aid;
keep  aid scid  h1gi20 h1to5 h1to7 h1rm14 h1rf14 h1pf30 h1to50
h1pf32 h1pf33 h1pf34 h1pf35 h1pf36 h1pf18 h1pf19 h1pf20 h1pf21
h1wp1 h1wp2 h1wp3 h1wp4 h1wp5 h1wp6 h1wp7 h1ts3
h1rm1 h1rm4 
h1wp9 h1wp10 h1wp11 h1wp12;
merge m:m aid using sfriend_sort;
drop _merge;

destring , replace;

/* school-grade */

rename h1gi20 grade;
drop if grade==96 | grade==97 | grade==98 | grade==99;


/*** SEX ***/

gen sex_miss=0;
replace sex_miss=1 if s2==9 | s2==.; /*multiple choice*/
gen male=.;
replace male=0 if s2==2;
replace male=1 if s2==1;
drop s2;

gen female=.;
replace female=1 if male==0;
replace female=0 if male==1;

drop if sex_miss==1;


/*** RACE ***/

/*recode race, multiple race ( if hisp then code as hisp, regardless of multiple race or not.*/

gen black=0;
replace black=1 if s6b==1;
gen asian=0;
replace asian=1 if s6b~=1 & s6c==1;
gen hisp=0;
replace hisp=1 if s6b~=1 & s6c~=1 & s4==1;
gen race_other=0;
replace race_other=1 if s6b~=1 & s6c~=1 & s4~=1 & s6d==1; 
replace race_other=1 if s6b~=1 & s6c~=1 & s4~=1 & s6e==1;
gen white=0;
replace white=1 if s6b~=1 & s6c~=1 & s4~=1 & s6d~=1 & s6e~=1 & s6a==1;

gen race_miss=. ;
replace race_miss=1 if black==0 & asian==0 & hisp==0 & race_other==0 & white==0;

replace black=. if race_miss==1;
replace asian=. if race_miss==1;
replace hisp=. if race_miss==1;
replace race_other=. if race_miss==1;
replace white=. if race_miss==1;

/* omitted: black */

drop if race_miss==1;

drop s4 s6a s6b s6c s6d s6e;

/* smoke dummy and smoke frequency*/


gen smoke_freq=.;
replace smoke_freq=0      if s59a==0;
replace smoke_freq=0.029  if s59a==1;
replace smoke_freq=0.25   if s59a==2;
replace smoke_freq=0.625  if s59a==3;
replace smoke_freq=1.5    if s59a==4;
replace smoke_freq=4      if s59a==5;
replace smoke_freq=7      if s59a==6;

gen smoke_dum=.;
replace smoke_dum=0       if s59a==0 | s59a==1;
replace smoke_dum=1       if smoke_freq>0.029 & smoke_freq~=.;
drop if smoke_freq==.;
drop if smoke_dum==.;	



/*  taught in school */

gen taught=0;
replace taught=1 if h1ts3==1;

/* cigarettes easily available at home */

gen ciga_home=0;
replace ciga_home=1 if h1to50==1;

/* parents smoking */

rename h1rm14 monther_smoke;
rename h1rf14 father_smoke;
gen smoke_parent=0;
replace smoke_parent=1 if monther_smoke==1;
replace smoke_parent=1 if father_smoke==1;


/*** MOM'S EDUCATION ***/

gen less_hs=0;
replace less_hs=1 if h1rm1==1 | h1rm1==2 | h1rm1==3 | h1rm1==10;
gen hs=0;
replace hs=1 if h1rm1==4 | h1rm1==5;
gen more_hs=0;
replace more_hs=1 if h1rm1==6 | h1rm1==7 | h1rm1==8 | h1rm1==9;

gen momedu_skip=0;
replace momedu_skip=1 if h1rm1==97;

gen momedu_miss=0;
replace momedu_miss=1 if h1rm1==.|h1rm1==11|h1rm1==12|h1rm1==96|h1rm1==98;


/* Mom occupation */

gen Homemaker=1 if h1rm4==16;
replace Homemaker=0 if h1rm4~=16;
gen Prof1=1 if h1rm4==1;
replace Prof1=0 if h1rm4~=1;
gen Prof2=1 if h1rm4==2;
replace Prof2=0 if h1rm4~=2;
gen Manager=1 if h1rm4==3;
replace Manager=0 if h1rm4~=3 ;
gen Technical=1 if h1rm4==4;
replace Technical=0 if h1rm4~=4;
gen Office=1 if h1rm4==5;
replace Office=0 if h1rm4~=5;
gen Sales=1 if h1rm4==6;
replace Sales=0 if h1rm4~=6;
gen Restaurant=1 if h1rm4==7;
replace Restaurant=0 if h1rm4~=7;
gen Craft=1 if h1rm4==8;
replace Craft=0 if h1rm4~=8;
gen Construction=1 if h1rm4==9;
replace Construction=0 if h1rm4~=9;
gen Mechanic=1 if h1rm4==10;
replace Mechanic=0 if h1rm4~=10;
gen Factory=1 if h1rm4==11;
replace Factory=0 if h1rm4~=11;
gen Trans=1 if h1rm4==12;
replace Trans=0 if h1rm4~=12;
gen Military=1 if h1rm4==13;
replace Military=0 if h1rm4~=13;
gen Farm=1 if h1rm4==14;
replace Farm=0 if h1rm4~=14;
gen momjob_skip=0;
replace momjob_skip=1 if h1rm4==97;
gen momjob_miss=0;
replace momjob_miss=1 if h1rm4==.|h1rm4==96|h1rm4==98|h1rm4==99;

/* combine*/
gen prof=0;
replace prof=1 if h1rm4==1 | h1rm4==2 |h1rm4==3;
gen home=0;
replace home=1 if h1rm4==16;
gen job_other=0;
replace job_other=1 if h1rm4==4 |h1rm4==5 |h1rm4==6 
|h1rm4==7 |h1rm4==8 |h1rm4==9 |h1rm4==10 |h1rm4==11 |h1rm4==12 |h1rm4==13 |h1rm4==14;



/*** Question of parent control ***/

drop if h1wp1==6 | h1wp1==7 | h1wp1==8 | h1wp1==9;
drop if h1wp2==6 | h1wp2==7 | h1wp2==8 | h1wp2==9; 
drop if h1wp3==6 | h1wp3==7 | h1wp3==8 | h1wp3==9;
drop if h1wp4==6 | h1wp4==7 | h1wp4==8 | h1wp4==9;
drop if h1wp5==6 | h1wp5==7 | h1wp5==8 | h1wp5==9;
drop if h1wp6==6 | h1wp6==7 | h1wp6==8 | h1wp6==9; 
drop if h1wp7==6 | h1wp7==7 | h1wp7==8 | h1wp7==9;

egen parent_control=rowmean(h1wp1 h1wp2 h1wp3 h1wp4 h1wp5 h1wp6 h1wp7);

/*
factor h1wp1 h1wp2 h1wp3 h1wp4 h1wp5 h1wp6 h1wp7;
rotate;
predict parent_control;
drop if parent_control==.;
*/

/*** Question of maternal care ***/

drop if h1wp9==6  | h1wp9==7  | h1wp9==8  | h1wp9==9;
drop if h1wp10==6 | h1wp10==7 | h1wp10==8 | h1wp10==9; 
drop if h1wp11==6 | h1wp11==7 | h1wp11==8 | h1wp11==9;
drop if h1wp12==6 | h1wp12==7 | h1wp12==8 | h1wp12==9;

egen maternal_care=rowmean(h1wp9 h1wp10 h1wp11 h1wp12);
/*
factor h1wp9 h1wp10 h1wp11 h1wp12;
rotate;
predict mother_care;
drop if mother_care==.;
*/


/*** Question of neuroticism Scale ***/ 

gen h1pf30_new=.;
replace h1pf30_new=1 if h1pf30==5;
replace h1pf30_new=2 if h1pf30==4;
replace h1pf30_new=3 if h1pf30==3;
replace h1pf30_new=4 if h1pf30==2;
replace h1pf30_new=5 if h1pf30==1;

gen h1pf32_new=.;
replace h1pf32_new=1 if h1pf32==5;
replace h1pf32_new=2 if h1pf32==4;
replace h1pf32_new=3 if h1pf32==3;
replace h1pf32_new=4 if h1pf32==2;
replace h1pf32_new=5 if h1pf32==1;

gen h1pf33_new=.;
replace h1pf33_new=1 if h1pf33==5;
replace h1pf33_new=2 if h1pf33==4;
replace h1pf33_new=3 if h1pf33==3;
replace h1pf33_new=4 if h1pf33==2;
replace h1pf33_new=5 if h1pf33==1;

gen h1pf34_new=.;
replace h1pf34_new=1 if h1pf34==5;
replace h1pf34_new=2 if h1pf34==4;
replace h1pf34_new=3 if h1pf34==3;
replace h1pf34_new=4 if h1pf34==2;
replace h1pf34_new=5 if h1pf34==1;


gen h1pf35_new=.;
replace h1pf35_new=1 if h1pf35==5;
replace h1pf35_new=2 if h1pf35==4;
replace h1pf35_new=3 if h1pf35==3;
replace h1pf35_new=4 if h1pf35==2;
replace h1pf35_new=5 if h1pf35==1;


gen h1pf36_new=.;
replace h1pf36_new=1 if h1pf36==5;
replace h1pf36_new=2 if h1pf36==4;
replace h1pf36_new=3 if h1pf36==3;
replace h1pf36_new=4 if h1pf36==2;
replace h1pf36_new=5 if h1pf36==1;


factor h1pf30_new h1pf32_new h1pf33_new h1pf34_new h1pf35_new h1pf36_new;
rotate;
predict neuroticism;
drop if neuroticism==.;

pca h1pf30_new h1pf32_new h1pf33_new h1pf34_new h1pf35_new h1pf36_new;


sort scid;
by scid: egen neuroticism_mean=mean(neuroticism);
gen high_neuroticism=0;
replace high_neuroticism=1 if neuroticism>=neuroticism_mean;


/*** Extraversion Measure ***/ 


gen s62b_new=.;
replace s62b_new=1 if s62b==5;
replace s62b_new=2 if s62b==4;
replace s62b_new=3 if s62b==3;
replace s62b_new=4 if s62b==2;
replace s62b_new=5 if s62b==1;

gen s62e_new=.;
replace s62e_new=1 if s62e==5;
replace s62e_new=2 if s62e==4;
replace s62e_new=3 if s62e==3;
replace s62e_new=4 if s62e==2;
replace s62e_new=5 if s62e==1;

gen s62o_new=.;
replace s62o_new=1 if s62o==5;
replace s62o_new=2 if s62o==4;
replace s62o_new=3 if s62o==3;
replace s62o_new=4 if s62o==2;
replace s62o_new=5 if s62o==1;

factor s62b_new s62e_new s62o_new;
rotate;
predict extraversion;
drop if extraversion==.;


sort scid;
by scid: egen extraversion_mean=mean(extraversion);
gen high_extraversion=0;
replace high_extraversion=1 if extraversion>=extraversion_mean;


/*** Question of conscientiousness Scale ***/

gen h1pf18_new=.;
replace h1pf18_new=1 if h1pf18==5;
replace h1pf18_new=2 if h1pf18==4;
replace h1pf18_new=3 if h1pf18==3;
replace h1pf18_new=4 if h1pf18==2;
replace h1pf18_new=5 if h1pf18==1;


gen h1pf19_new=.;
replace h1pf19_new=1 if h1pf19==5;
replace h1pf19_new=2 if h1pf19==4;
replace h1pf19_new=3 if h1pf19==3;
replace h1pf19_new=4 if h1pf19==2;
replace h1pf19_new=5 if h1pf19==1;


gen h1pf20_new=.;
replace h1pf20_new=1 if h1pf20==5;
replace h1pf20_new=2 if h1pf20==4;
replace h1pf20_new=3 if h1pf20==3;
replace h1pf20_new=4 if h1pf20==2;
replace h1pf20_new=5 if h1pf20==1;


gen h1pf21_new=.;
replace h1pf21_new=1 if h1pf21==5;
replace h1pf21_new=2 if h1pf21==4;
replace h1pf21_new=3 if h1pf21==3;
replace h1pf21_new=4 if h1pf21==2;
replace h1pf21_new=5 if h1pf21==1;


factor h1pf18_new h1pf19_new h1pf20_new h1pf21_new;
rotate;
predict conscientiousness;
drop if conscientiousness==.;

sort scid;
by scid: egen conscientiousness_mean=mean(conscientiousness);
gen high_conscientiousness=0;
replace high_conscientiousness=1 if conscientiousness>=conscientiousness_mean;



/* define group at the school level */

sort scid;
by scid: gen group_size=_N;
drop if group_size<=10 | group_size>=300;

/*
egen keeplist = anymatch(scid), values( 
1 2 3 6 7 8 9 10 12 14 17 19 21 22 23 24 27 28 39 55 64 66 68 81 85 88
90 93 106 109 114 115 117 118 119 120 121 122 123 126 127 133 139 141
144 146 147 150 152 153 154 155 157 158 160 162 164 166 167 168 170 171
172 174 176 177 185 186 187 191 193 194 369 371 );	
keep if keeplist;
*/

egen ggroup = group(scid);

sort ggroup high_conscientiousness;


tempfile temp_data;
save "`temp_data'"; 


*corr neuroticism extraversion conscientiousness;
*keep if high_extraversion==0;

*order smoke_dum smoke_freq neuroticism extraversion male black hisp asian race_other prof home job_other conscientiousness smoke_parent taught parent_control maternal_care; 
*sum smoke_dum smoke_freq neuroticism conscientiousness extraversion smoke_parent taught parent_control maternal_care male black hisp asian race_other prof home job_other ;
*keep smoke_dum smoke_freq neuroticism conscientiousness extraversion smoke_parent taught parent_control maternal_care male black hisp asian race_other prof home job_other ;
*sutex , minmax;


global dirout  "D:\research\2014_health_study\data\inhome\smoke\conscientiousness";
*global dirout  "D:\research\2014_health_study\data\inhome\smoke_subsample\few_regressor";



cd $dirout;

#delimit cr
	
	local group_number=ggroup[_N]
	forvalues g = 1(1)`group_number'{
		 use "`temp_data'", replace
	     drop if ggroup~=`g'
		 order high_conscientiousness smoke_dum smoke_freq neuroticism conscientiousness extraversion smoke_parent taught parent_control maternal_care male black hisp asian race_other prof home job_other
		 outsheet high_conscientiousness smoke_dum smoke_freq neuroticism conscientiousness extraversion smoke_parent taught parent_control maternal_care male black hisp asian race_other prof home job_other using .\group\group`g'.dat, nonames nol replace	
		 *outsheet high_neuroticism smoke_dum smoke_freq neuroticism extraversion male black hisp asian race_other prof home job_other using .\group\group`g'.dat, nonames nol replace	
		 
		 local g = `g' + 1
	 }
	 

	/*** DYADIC DATA: GRADE  ***/

	forvalues g = 1(1)`group_number'{
	    use "`temp_data'", replace
	    drop if ggroup~=`g'
		keep  grade		
		version 10
		mata:  st_view(grade=., ., "grade")
		mata:  GRADE=J(rows(grade),rows(grade),0)
		mata {
		for (i=1; i<=rows(grade); i++) {
    			for (j=1; j<=rows(grade); j++) {                         
         			if(grade[i]==grade[j]) GRADE[i,j]=1			
				}			                         
                 }	    	 
		}       			
		mata: st_matrix("GRADE",GRADE)
		mata: mata clear
		
		svmat double GRADE, names(GRADE)
		drop grade
		outsheet using .\grade\grade`g'.dat, nonames replace
        local g = `g' + 1
		}

	/*** DYADIC DATA: SEX ***/

	forvalues g = 1(1)`group_number'{
	    use "`temp_data'", replace
	    drop if ggroup~=`g'
		keep male
		version 10  
		mata:  st_view(male=., ., "male")
		mata:  MALE=J(rows(male),rows(male),0)
		mata {
		for (i=1; i<=rows(male); i++) {
    			for (j=1; j<=rows(male); j++) {                         
         			if(male[i]==male[j]) MALE[i,j]=1			
				}			                         
                 }	    	
		}         		
		mata: st_matrix("MALE",MALE)
		mata: mata clear
		
		svmat double MALE, names(MALE)
		drop male
		outsheet using .\sex\sex`g'.dat, nonames replace
		local g = `g' + 1
		}


	/*** DYADIC DATA: RACE ***/

	forvalues g = 1(1)`group_number'{
	    use "`temp_data'", replace
	    drop if ggroup~=`g'
		keep  black asian hisp race_other white 
		version 10 
		mata:  st_view(black=., ., "black")
		mata:  st_view(asian=., ., "asian")
		mata:  st_view(hisp=., ., "hisp")
		mata:  st_view(white=., ., "white")
		mata:  st_view(race_other=., ., "race_other")	
		mata:  RACE=J(rows(white),rows(white),0)
		mata {
		for (i=1; i<=rows(white); i++) {
    			for (j=1; j<=rows(white); j++) {                         
         			if(black[i]==black[j] & asian[i]==asian[j] & hisp[i]==hisp[j] & white[i]==white[j] & race_other[i]==race_other[j] ) RACE[i,j]=1			
				}			                         
                 }	    	   
		}      			
		mata: st_matrix("RACE",RACE)
		mata: mata clear
		
		svmat double RACE, names(RACE)
		drop black asian hisp race_other white
		outsheet using .\race\race`g'.dat, nonames replace	
        local g = `g' + 1
		}


	 
	 
	 /*** FRIENDSHIP NETWORK  ***/

	forvalues g = 1(1)`group_number'{
		use "`temp_data'", replace
		drop if ggroup~=`g'
		keep  aid fid1 fid2 fid3 fid4 fid5 fid6 fid7 fid8 fid9 fid10
		version 10            
		mata:  st_view(aid=., ., "aid")
		mata:  st_view(fid1=., ., "fid1")
		mata:  st_view(fid2=., ., "fid2")
		mata:  st_view(fid3=., ., "fid3")
		mata:  st_view(fid4=., ., "fid4")
		mata:  st_view(fid5=., ., "fid5")
		mata:  st_view(fid6=., ., "fid6")
		mata:  st_view(fid7=., ., "fid7")
		mata:  st_view(fid8=., ., "fid8")
		mata:  st_view(fid9=., ., "fid9")
		mata:  st_view(fid10=., .,"fid10")
		mata:  w=J(rows(aid),rows(aid),.)
		mata:  fid=(fid1, fid2, fid3, fid4, fid5, fid6, fid7, fid8, fid9, fid10)
		
		mata {
		for (i=1; i<=rows(aid); i++) {
    			for (j=1; j<=rows(aid); j++) {                         
         		w[i,j] =aid[j] 
	  			for (k=1; k<=10; k++) {
				if(w[i,j]==fid[i,k]) w[i,j]=1			
				}			                         
                 }	   	
         	}
		}
		mata {				
		for (i=1; i<=rows(aid); i++) {
    			for (j=1; j<=rows(aid); j++) {                         
	  			for (k=1; k<=10; k++) {
				if(w[i,j]~=1) w[i,j]=0		
				}			                       
                 }	    	
         	}	
		}
		mata: st_matrix("w",w)
		mata: mata clear
		
		svmat double w, names(w)
		drop aid fid1 fid2 fid3 fid4 fid5 fid6 fid7 fid8 fid9 fid10	
		outsheet using .\network\network`g'.dat, nonames nol replace	
		 local g = `g' + 1
		}
	 
	 
