clear 
mata: mata clear
set more off
#delimit;
global dirdata  "D:\research\AddHealth"; 

cd $dirdata;
#delimit;
use sfriend,clear;
sort sqid;
save sfriend_sort,replace;


use Inschool.dta,clear;
keep sqid aid sschlcde s1 s2 s3 s4 s6a s6b s6c s6d s6e s9 s10 s10a s10b s10c s10d s11 s12 s14 s15 s17 s18 s20 s21 s47 s48 
s29a s29b s29c s29d s29e s30a s30b s30c s30d s30e s59a s59b s59c s59d s59e s59f s59g s44a1 s44a2 s44a3 s44a4 s44a5 s44a6 s44a7 
s44a8 s44a9 s44a10 s44a11 s44a12 s44a13 s44a14 s44a15 s44a16 s44a17 s44a18 s44a19 s44a20 s44a21 s44a22 s44a23 s44a24 s44a25 
s44a26 s44a27 s44a28 s44a29 s44a30 s44a31 s44a32 s44a33 s62b s62e s62o s62h s62k s62m s62n s62o s62p;
sort sqid;
merge sqid using sfriend_sort;
tab _merge;
drop _merge;
destring , replace;


/***  ID & SCHOOL ID ***/

drop sqid;
drop if aid==.;
rename sschlcde scid;


/* school-grade */

rename s3 grade;
drop if grade==.;
drop if grade==99;
drop if grade==13;

/*** SEX ***/

gen sex_miss=0;
replace sex_miss=1 if s2==9 | s2==.; /*multiple choice*/
gen male=.;
replace male=0 if s2==2;
replace male=1 if s2==1;
drop s2;

gen female=.;
replace female=1 if male==0;
replace female=0 if male==1;

drop if sex_miss==1;


/*** RACE ***/

/*recode race, multiple race ( if hisp then code as hisp, regardless of multiple race or not.*/

gen black=0;
replace black=1 if s6b==1;
gen asian=0;
replace asian=1 if s6b~=1 & s6c==1;
gen hisp=0;
replace hisp=1 if s6b~=1 & s6c~=1 & s4==1;
gen race_other=0;
replace race_other=1 if s6b~=1 & s6c~=1 & s4~=1 & s6d==1; 
replace race_other=1 if s6b~=1 & s6c~=1 & s4~=1 & s6e==1;
gen white=0;
replace white=1 if s6b~=1 & s6c~=1 & s4~=1 & s6d~=1 & s6e~=1 & s6a==1;

gen race_miss=. ;
replace race_miss=1 if black==0 & asian==0 & hisp==0 & race_other==0 & white==0;

replace black=. if race_miss==1;
replace asian=. if race_miss==1;
replace hisp=. if race_miss==1;
replace race_other=. if race_miss==1;
replace white=. if race_miss==1;

/* omitted: black */

drop if race_miss==1;

drop s4 s6a s6b s6c s6d s6e;

/* smoke dummy and smoke frequency*/


gen smoke_freq=.;
replace smoke_freq=0      if s59a==0;
replace smoke_freq=0.029  if s59a==1;
replace smoke_freq=0.25   if s59a==2;
replace smoke_freq=0.625  if s59a==3;
replace smoke_freq=1.5    if s59a==4;
replace smoke_freq=4      if s59a==5;
replace smoke_freq=7      if s59a==6;

gen smoke_dum=.;
replace smoke_dum=0       if s59a==0 | s59a==1;
replace smoke_dum=1       if smoke_freq>0.029 & smoke_freq~=.;
drop if smoke_freq==.;
drop if smoke_dum==.;	




/*** MOM'S EDUCATION ***/

gen less_hs=0;
replace less_hs=1 if s12==1 | s12==2 | s12==10;
gen hs=0;
replace hs=1 if s12==3 | s12==4;
gen more_hs=0;
replace more_hs=1 if s12==5 | s12==6 | s12==7 | s12==8;

gen momedu_skip=0;
replace momedu_skip=1 if s12==97;

gen momedu_miss=0;
replace momedu_miss=1 if s12==.|s12==9|s12==11|s12==99;
/*omitted:hs, leave out monedu_skip--not now*/

/*
replace less_hs=. if momedu_miss==1;
replace hs=. if momedu_miss==1;
replace more_hs=. if momedu_miss==1;
*/

/*** MOM'S OCCUPATION ***/


gen Homemaker=1 if s14==1;
replace Homemaker=0 if s14~=1;
gen Prof1=1 if s14==2;
replace Prof1=0 if s14~=2;
gen Prof2=1 if s14==3;
replace Prof2=0 if s14~=3;
gen Manager=1 if s14==4;
replace Manager=0 if s14~=4 ;
gen Technical=1 if s14==5;
replace Technical=0 if s14~=5;
gen Office=1 if s14==6;
replace Office=0 if s14~=6;
gen Sales=1 if s14==7;
replace Sales=0 if s14~=7;
gen Restaurant=1 if s14==8;
replace Restaurant=0 if s14~=8;
gen Craft=1 if s14==9;
replace Craft=0 if s14~=9;
gen Construction=1 if s14==10;
replace Construction=0 if s14~=10;
gen Mechanic=1 if s14==11;
replace Mechanic=0 if s14~=11;
gen Factory=1 if s14==12;
replace Factory=0 if s14~=12;
gen Trans=1 if s14==13;
replace Trans=0 if s14~=13;
gen Military=1 if s14==14;
replace Military=0 if s14~=14;
gen Farm=1 if s14==15;
replace Farm=0 if s14~=15;
gen nowork_nodisabled=1 if s14==16;
replace nowork_nodisabled=0 if s14~=16;
gen nowork_disabled=1 if s14==17;
replace nowork_disabled=0 if s14~=17;
gen Retired=1 if s14==18;
replace Retired=0 if s14~=18;
gen Welfare=1 if s14==19;
replace Welfare=0 if s14~=19;

gen momjob_skip=0;
replace momjob_skip=1 if s14==97;

gen momjob_miss=0;
replace momjob_miss=1 if s14==.|s14==20|s14==99;
/*omitted: Homekaker, leave out momjob_skip--not now, since skip captures the same information as "not live with Mom"*/

/* combine*/
gen prof=0;
replace prof=1 if s14==2 | s14==3 |s14==4;
gen home=0;
replace home=1 if s14==1 |s14==16 |s14==17 |s14==18 ;
gen job_other=0;
replace job_other=1 if s14==5 |s14==6 |s14==7 |s14==8 |s14==9 |s14==10 |s14==11 |s14==12 |s14==13 |s14==14 |s14==15;

/* now have Home (omitted), Prof, job_other, welfare and missing*/
/*
replace Prof=. if momjob_miss==1;
replace Home=. if momjob_miss==1;
replace job_other=. if momjob_miss==1;
*/


gen work_pay=0;
replace work_pay=1 if s15==1;
gen work_pay_skip=0;
replace work_pay_skip=1 if s15==7;

gen work_pay_miss=0;
replace work_pay_miss=1 if s15==.|s15==8|s15==9;




/*** Question of neuroticism Scale ***/ 

gen s62h_new=.;
replace s62h_new=1 if s62h==5;
replace s62h_new=2 if s62h==4;
replace s62h_new=3 if s62h==3;
replace s62h_new=4 if s62h==2;
replace s62h_new=5 if s62h==1;

gen s62k_new=.;
replace s62k_new=1 if s62k==5;
replace s62k_new=2 if s62k==4;
replace s62k_new=3 if s62k==3;
replace s62k_new=4 if s62k==2;
replace s62k_new=5 if s62k==1;

gen s62m_new=.;
replace s62m_new=1 if s62m==5;
replace s62m_new=2 if s62m==4;
replace s62m_new=3 if s62m==3;
replace s62m_new=4 if s62m==2;
replace s62m_new=5 if s62m==1;

gen s62n_new=.;
replace s62n_new=1 if s62n==5;
replace s62n_new=2 if s62n==4;
replace s62n_new=3 if s62n==3;
replace s62n_new=4 if s62n==2;
replace s62n_new=5 if s62n==1;


gen s62o_new=.;
replace s62o_new=1 if s62o==5;
replace s62o_new=2 if s62o==4;
replace s62o_new=3 if s62o==3;
replace s62o_new=4 if s62o==2;
replace s62o_new=5 if s62o==1;


gen s62p_new=.;
replace s62p_new=1 if s62p==5;
replace s62p_new=2 if s62p==4;
replace s62p_new=3 if s62p==3;
replace s62p_new=4 if s62p==2;
replace s62p_new=5 if s62p==1;


factor s62h_new s62k_new s62m_new s62n_new s62o_new s62p_new;
rotate;
predict neuroticism;
drop if neuroticism==.;

pca s62h_new s62k_new s62m_new s62n_new s62o_new s62p_new;


sort scid;
by scid: egen neuroticism_mean=mean(neuroticism);
gen high_neuroticism=0;
replace high_neuroticism=1 if neuroticism>=neuroticism_mean;


/*** Extraversion Measure ***/ 


gen s62b_new=.;
replace s62b_new=1 if s62b==5;
replace s62b_new=2 if s62b==4;
replace s62b_new=3 if s62b==3;
replace s62b_new=4 if s62b==2;
replace s62b_new=5 if s62b==1;

gen s62e_new=.;
replace s62e_new=1 if s62e==5;
replace s62e_new=2 if s62e==4;
replace s62e_new=3 if s62e==3;
replace s62e_new=4 if s62e==2;
replace s62e_new=5 if s62e==1;

factor s62b_new s62e_new s62o_new;
rotate;
predict extraversion;
drop if extraversion==.;


sort scid;
by scid: egen extraversion_mean=mean(extraversion);
gen high_extraversion=0;
replace high_extraversion=1 if extraversion>=extraversion_mean;


/* prepare friendship network */

foreach friends in mf1aid mf2aid mf3aid mf4aid mf5aid ff1aid ff2aid ff3aid ff4aid ff5aid {;
replace `friends'=. if `friends'==77777777 | `friends'==88888888 | `friends'==99959995 | `friends'==99999999;

};
rename mf1aid fid1;
rename mf2aid fid2;
rename mf3aid fid3;
rename mf4aid fid4;
rename mf5aid fid5;
rename ff1aid fid6;
rename ff2aid fid7;
rename ff3aid fid8;
rename ff4aid fid9;
rename ff5aid fid10;

drop s10 s10a s10b s10c s10d s11 s12 s14 s15 s17 s20 s21 s59a s59b s59c s59d s59e s59f s59g;
sort aid;


sort scid;
by scid: gen group_size=_N;

egen keeplist = anymatch(scid), values( 
1 2 3 6 7 8 9 10 12 14 17 19 21 22 23 24 27 28 39 55 64 66 68 81 85 88
90 93 106 109 114 115 117 118 119 120 121 122 123 126 127 133 139 141
144 146 147 150 152 153 154 155 157 158 160 162 164 166 167 168 170 171
172 174 176 177 185 186 187 191 193 194 369 371 );	
		
keep if keeplist;
 
egen ggroup = group(scid);


sort ggroup high_neuroticism;


tempfile temp_data;
save "`temp_data'"; 

sum smoke_dum smoke_freq neuroticism extraversion male black hisp asian race_other prof home job_other ;
keep smoke_dum smoke_freq neuroticism extraversion male black hisp asian race_other prof home job_other ;
sutex , minmax;


global dirout  "D:\research\2014_health_study\data\inschool\smoke_subsample\neuroticism";

cd $dirout;

#delimit cr
	
	local group_number=ggroup[_N]
	forvalues g = 1(1)`group_number'{
		 use "`temp_data'", replace
	     drop if ggroup~=`g'
		 outsheet high_neuroticism smoke_dum smoke_freq neuroticism extraversion male black hisp asian race_other prof home job_other using .\group\group`g'.dat, nonames nol replace	
		 local g = `g' + 1
	 }
	 

	/*** DYADIC DATA: GRADE  ***/

	forvalues g = 1(1)`group_number'{
	    use "`temp_data'", replace
	    drop if ggroup~=`g'
		keep  grade		
		version 10
		mata:  st_view(grade=., ., "grade")
		mata:  GRADE=J(rows(grade),rows(grade),0)
		mata {
		for (i=1; i<=rows(grade); i++) {
    			for (j=1; j<=rows(grade); j++) {                         
         			if(grade[i]==grade[j]) GRADE[i,j]=1			
				}			                         
                 }	    	 
		}       			
		mata: st_matrix("GRADE",GRADE)
		mata: mata clear
		
		svmat double GRADE, names(GRADE)
		drop grade
		outsheet using .\grade\grade`g'.dat, nonames replace
        local g = `g' + 1
		}

	/*** DYADIC DATA: SEX ***/

	forvalues g = 1(1)`group_number'{
	    use "`temp_data'", replace
	    drop if ggroup~=`g'
		keep male
		version 10  
		mata:  st_view(male=., ., "male")
		mata:  MALE=J(rows(male),rows(male),0)
		mata {
		for (i=1; i<=rows(male); i++) {
    			for (j=1; j<=rows(male); j++) {                         
         			if(male[i]==male[j]) MALE[i,j]=1			
				}			                         
                 }	    	
		}         		
		mata: st_matrix("MALE",MALE)
		mata: mata clear
		
		svmat double MALE, names(MALE)
		drop male
		outsheet using .\sex\sex`g'.dat, nonames replace
		local g = `g' + 1
		}


	/*** DYADIC DATA: RACE ***/

	forvalues g = 1(1)`group_number'{
	    use "`temp_data'", replace
	    drop if ggroup~=`g'
		keep  black asian hisp race_other white 
		version 10 
		mata:  st_view(black=., ., "black")
		mata:  st_view(asian=., ., "asian")
		mata:  st_view(hisp=., ., "hisp")
		mata:  st_view(white=., ., "white")
		mata:  st_view(race_other=., ., "race_other")	
		mata:  RACE=J(rows(white),rows(white),0)
		mata {
		for (i=1; i<=rows(white); i++) {
    			for (j=1; j<=rows(white); j++) {                         
         			if(black[i]==black[j] & asian[i]==asian[j] & hisp[i]==hisp[j] & white[i]==white[j] & race_other[i]==race_other[j] ) RACE[i,j]=1			
				}			                         
                 }	    	   
		}      			
		mata: st_matrix("RACE",RACE)
		mata: mata clear
		
		svmat double RACE, names(RACE)
		drop black asian hisp race_other white
		outsheet using .\race\race`g'.dat, nonames replace	
        local g = `g' + 1
		}


	 
	 
	 /*** FRIENDSHIP NETWORK  ***/

	forvalues g = 1(1)`group_number'{
		use "`temp_data'", replace
		drop if ggroup~=`g'
		keep  aid fid1 fid2 fid3 fid4 fid5 fid6 fid7 fid8 fid9 fid10
		version 10            
		mata:  st_view(aid=., ., "aid")
		mata:  st_view(fid1=., ., "fid1")
		mata:  st_view(fid2=., ., "fid2")
		mata:  st_view(fid3=., ., "fid3")
		mata:  st_view(fid4=., ., "fid4")
		mata:  st_view(fid5=., ., "fid5")
		mata:  st_view(fid6=., ., "fid6")
		mata:  st_view(fid7=., ., "fid7")
		mata:  st_view(fid8=., ., "fid8")
		mata:  st_view(fid9=., ., "fid9")
		mata:  st_view(fid10=., .,"fid10")
		mata:  w=J(rows(aid),rows(aid),.)
		mata:  fid=(fid1, fid2, fid3, fid4, fid5, fid6, fid7, fid8, fid9, fid10)
		
		mata {
		for (i=1; i<=rows(aid); i++) {
    			for (j=1; j<=rows(aid); j++) {                         
         		w[i,j] =aid[j] 
	  			for (k=1; k<=10; k++) {
				if(w[i,j]==fid[i,k]) w[i,j]=1			
				}			                         
                 }	   	
         	}
		}
		mata {				
		for (i=1; i<=rows(aid); i++) {
    			for (j=1; j<=rows(aid); j++) {                         
	  			for (k=1; k<=10; k++) {
				if(w[i,j]~=1) w[i,j]=0		
				}			                       
                 }	    	
         	}	
		}
		mata: st_matrix("w",w)
		mata: mata clear
		
		svmat double w, names(w)
		drop aid fid1 fid2 fid3 fid4 fid5 fid6 fid7 fid8 fid9 fid10	
		outsheet using .\network\network`g'.dat, nonames nol replace	
		 local g = `g' + 1
		}
	 
	 
